#---balloonhelp
package provide FR_balloonHelp 0.1


namespace eval ::FR_balloonHelp \
{
 namespace export create destroy
}


proc ::FR_balloonHelp::create {} \
{
 variable COUNT; variable INFO; variable wl
 
 if {![info exists COUNT]} \
 {
  toplevel .balloonhelp -background black -borderwidth 1 -relief flat
  label .balloonhelp.info -background white -wraplength 3i -justify left
   
  pack .balloonhelp.info -side left -fill x
  wm overrideredirect .balloonhelp 1
  wm withdraw .balloonhelp

  set COUNT 1
 } 

 #---we collect all widgets with a help
 set WIDGET_LIST [array names wl]
 if {[llength $WIDGET_LIST] == 0} {return}

 
 #---if there not yet a binding - we make it, but only if window exists yet
 foreach ARG $WIDGET_LIST \
 {
  if {[winfo exists $ARG]} \
  {
   if {![info exists INFO($ARG)]} \
   {
    bind $ARG <Enter> {::FR_balloonHelp::pending %W}
    bind $ARG <Leave> {::FR_balloonHelp::cancel}
   
    set INFO($ARG) $wl($ARG)
   }
  }
 }
}


#---we hide the balloonhelp with unsetting the binding
proc ::FR_balloonHelp::destroy {} \
{ 
 variable wl
 
 set WIDGET_LIST [array names wl]
 if {[llength $WIDGET_LIST] == 0} {return}
 
 foreach ARG $WIDGET_LIST \
 {
  if {[winfo exists $ARG]} \
  {
   bind $ARG <Enter> ""
   bind $ARG <Leave> ""
  }
 }
}

proc ::FR_balloonHelp::cancel {} \
{
 variable INFO
 
 if { [info exists INFO(pending)] } \
 {
  after cancel $INFO(pending)
  unset INFO(pending)
 }
 
 wm withdraw .balloonhelp
}


proc ::FR_balloonHelp::pending {widget} \
{
 variable INFO
 
 ::FR_balloonHelp::cancel
 set INFO(pending) [after 1500 [list ::FR_balloonHelp::show $widget]] 
}


proc ::FR_balloonHelp::show {widget} \
{
 variable INFO
 
 .balloonhelp.info configure -text $INFO($widget)
 
 set x [expr [winfo rootx $widget]+10]
 set y [expr [winfo rooty $widget]+[winfo height $widget]]
 
 update
 
 set ballonhelp_width [expr {$x+[winfo width .balloonhelp.info]}]
 
 if { $ballonhelp_width > [winfo screenwidth $widget] } \
 {
  set x [expr {$x-[winfo width .balloonhelp.info]}]
 }
 
 wm geometry .balloonhelp +$x+$y
 wm deiconify .balloonhelp
 raise .balloonhelp
  
 #---it could be that during executing balloonhelp_show
 #---balloonhelp_cancel unset INFO(pending)
 if { [info exists INFO(pending)] } {unset INFO(pending)}
}



