#
#---a simple popup window
#
# -type "Entry (default)"
# -parent "<window which starts FR_popupWindow> | . (default)"
# -title "<your window title> | "Entry-box" (default)"
# -initialinput "<preload for the entry-box> | nothing (default)"
# -description "a label above the entry-box (e.g. for a description or fill out help)"
# -button "Dismiss | okcancel (default)"



package provide FR_popupWindow 0.1

package require FR_general


namespace eval ::FR_popupWindow \
{
 namespace export create
}


proc ::FR_popupWindow::buttonaction {FR_pW_path RETURNVALUE} \
{
 variable popupwindow
  
 if { $RETURNVALUE } \
 {
  set popupwindow($FR_pW_path,RETURN) [.$popupwindow($FR_pW_path,main).entrybox get]
 } else \
 {
  set popupwindow($FR_pW_path,RETURN) ""
 }
  
 focus $popupwindow($FR_pW_path,PARENT)
 destroy .$FR_pW_path
 set popupwindow($FR_pW_path,STOP) 1
}


proc ::FR_popupWindow::create {args} \
{
 variable popupwindow
 
 #---first we generate a toplevel name who doesn't exist yet
 set i 1
 while {[winfo exists .popup_window$i]} {incr i}
 set FR_pW_path "popup_window$i"
 

 set popupwindow($FR_pW_path,TYPE) "Entry"
 set popupwindow($FR_pW_path,PARENT) .
 set popupwindow($FR_pW_path,TITLE) ""
 set popupwindow($FR_pW_path,BUTTONS) "okcancel"
 set popupwindow($FR_pW_path,INI_INPUT) ""
 set popupwindow($FR_pW_path,DESCRIPTION) ""
 
 set popupwindow($FR_pW_path,STOP) 0
 set popupwindow($FR_pW_path,RETURN) ""
 
 
 for {set i 0} {$i < [llength $args]} {incr i 2} \
  {
   set arg [lindex $args $i]
   switch -glob -- $arg \
    {
     -type         {set popupwindow($FR_pW_path,TYPE) [lindex $args [expr {$i+1}]]} \
     -parent       {set popupwindow($FR_pW_path,PARENT) [lindex $args [expr {$i+1}]]} \
     -title        {set popupwindow($FR_pW_path,TITLE) [lindex $args [expr {$i+1}]]} \
     -initialinput {set popupwindow($FR_pW_path,INI_INPUT) [lindex $args [expr {$i+1}]]} \
     -description  {set popupwindow($FR_pW_path,DESCRIPTION) [lindex $args [expr {$i+1}]]} \
     -button       {set popupwindow($FR_pW_path,BUTTONS) [lindex $args [expr {$i+1}]]} \
     --            {break} \
     *             {error "unknown option: $arg"}
    }
   }

   
 if { $popupwindow($FR_pW_path,TYPE) eq "Entry" } \
 {
  if {$popupwindow($FR_pW_path,TITLE) eq ""} {set popupwindow($FR_pW_path,TITLE) [msgcat::mc "Entry-box"]}
 }


 toplevel .$FR_pW_path
 wm title .$FR_pW_path $popupwindow($FR_pW_path,TITLE)
 wm withdraw .$FR_pW_path

 frame .$FR_pW_path.frame1 -relief flat
 frame .$FR_pW_path.frame2 -relief flat

 pack  .$FR_pW_path.frame1 -side top -expand yes -fill both -padx 5 -pady 5
 pack  .$FR_pW_path.frame2 -side top -fill x

 #---We set a variable for each frame - so we can change the order of the frames later easier 
 set popupwindow($FR_pW_path,main) "$FR_pW_path.frame1"
 set popupwindow($FR_pW_path,bottom) "$FR_pW_path.frame2"
 
 label .$popupwindow($FR_pW_path,main).description -justify left -text $popupwindow($FR_pW_path,DESCRIPTION)
 
 entry .$popupwindow($FR_pW_path,main).entrybox -width 35 -background white -xscrollcommand ".$popupwindow($FR_pW_path,main).xsbar set"
 scrollbar .$popupwindow($FR_pW_path,main).xsbar -orient horizontal -command ".$popupwindow($FR_pW_path,main).entrybox xview"

 grid .$popupwindow($FR_pW_path,main).description -row 0 -sticky ws -padx 5 -pady 5
 grid .$popupwindow($FR_pW_path,main).entrybox -row 1 -sticky ew -padx 5
 grid .$popupwindow($FR_pW_path,main).xsbar -row 2 -sticky ew -padx 5 -pady {0 5}
 grid columnconfigure .$popupwindow($FR_pW_path,main) 0 -weight 1
 grid rowconfigure .$popupwindow($FR_pW_path,main) 0 -weight 1

  
 if { $popupwindow($FR_pW_path,INI_INPUT) ne "" } \
 {
  .$popupwindow($FR_pW_path,main).entrybox insert end $popupwindow($FR_pW_path,INI_INPUT)
  .$popupwindow($FR_pW_path,main).entrybox selection range 0 end
 }
 
 if { $popupwindow($FR_pW_path,BUTTONS) eq "Dismiss" } \
 {
  button .$popupwindow($FR_pW_path,bottom).cancel -text [msgcat::mc "Dismiss"] -state normal -command [list ::FR_popupWindow::buttonaction $FR_pW_path 0]

  pack .$popupwindow($FR_pW_path,bottom).cancel -side left -padx 5 -pady 5 -expand yes -fill x
  
  bind .$FR_pW_path <KeyPress-Escape> [list .$popupwindow($FR_pW_path,bottom).cancel invoke]
 }
 
 if { $popupwindow($FR_pW_path,BUTTONS) eq "okcancel" } \
 {
  set BUTTONTEXT [::FR_general::ButtonsWithSameWidth [list [msgcat::mc "Ok"] [msgcat::mc "Cancel"]]]
  
  button .$popupwindow($FR_pW_path,bottom).cancel -text [lindex $BUTTONTEXT 1] -state normal -width [lindex $BUTTONTEXT 2] -command [list ::FR_popupWindow::buttonaction $FR_pW_path 0]
   
  button .$popupwindow($FR_pW_path,bottom).okay -text [lindex $BUTTONTEXT 0] -state normal -width [lindex $BUTTONTEXT 2] -command [list ::FR_popupWindow::buttonaction $FR_pW_path 1]
   
  pack .$popupwindow($FR_pW_path,bottom).okay -side left -padx {5 0} -pady 5 -expand yes -fill x
  pack .$popupwindow($FR_pW_path,bottom).cancel -side left -padx 5 -pady 5 -expand yes -fill x
  
  bind .$FR_pW_path <KeyPress-Escape> [list .$popupwindow($FR_pW_path,bottom).cancel invoke]
  bind .$FR_pW_path <KeyPress-Return> [list .$popupwindow($FR_pW_path,bottom).okay invoke]
 }
 
 ::FR_general::CenterWindow .$FR_pW_path $popupwindow($FR_pW_path,PARENT)
 wm deiconify .$FR_pW_path
 wm protocol .$FR_pW_path WM_DELETE_WINDOW [list .$popupwindow($FR_pW_path,bottom).cancel invoke]
 
 focus .$popupwindow($FR_pW_path,main).entrybox
 
 vwait ::FR_popupWindow::popupwindow($FR_pW_path,STOP)
 return $popupwindow($FR_pW_path,RETURN)
}
