#---the dialog to add the translation

proc ::tk_msg::EditEntrySub {Message Translation} \
{
  variable VAR
  
  foreach Arg [list FR_entry FR_emptyBox] \
  {  
    package require $Arg
  }
  
  set VAR(EditEntryStop) 0
  set VAR(EditEntryReturnValue) ""
  
  
  set VAR(EditEntryWindow) "entry_window"
 
  if {[winfo exists .$VAR(EditEntryWindow)]} \
  {
    wm deiconify .$VAR(EditEntryWindow)
    return
  }
 
  ::FR_emptyBox::Create -window .$VAR(EditEntryWindow) -title [msgcat::mc "Please put in your translation"]
 
  labelframe .$VAR(EditEntryWindow).frame1 -relief groove -text [msgcat::mc "Comment:"] -foreground blue -padx 5 -pady 5
  frame .$VAR(EditEntryWindow).frame2 -relief flat

  pack  .$VAR(EditEntryWindow).frame1 -side top -expand yes -fill both -padx 5 -pady 5
  pack  .$VAR(EditEntryWindow).frame2 -side top -fill x
 
  set mainframe $VAR(EditEntryWindow).frame1
  set bottomframe $VAR(EditEntryWindow).frame2
 
  label .$mainframe.orginal_comment -justify left -text [msgcat::mc "The orginal text is:"]
  entry .$mainframe.orginal -width 50 -background white -xscrollcommand ".$mainframe.orginal_xsbar set"
  scrollbar .$mainframe.orginal_xsbar -orient horizontal -command ".$mainframe.orginal xview"

  label .$mainframe.translation_comment -justify left -text [msgcat::mc "Input the translated text:"]
  ::FR_entry::Create .$mainframe.translation
  .$mainframe.translation configure -width 50 -background white -xscrollcommand ".$mainframe.translation_xsbar set"
  scrollbar .$mainframe.translation_xsbar -orient horizontal -command ".$mainframe.translation xview"
  
  set VAR(TranslationEntry) $mainframe.translation
  
  set row 0
 
  grid .$mainframe.orginal_comment -row $row -sticky ws -padx 5 -pady 5
  grid .$mainframe.orginal -row [incr row] -sticky ew -padx 5
  grid .$mainframe.orginal_xsbar -row [incr row] -sticky ew -padx 5 -pady {0 5}
 
  grid .$mainframe.translation_comment -row [incr row] -sticky ws -padx 5 -pady 5
  grid .$mainframe.translation -row [incr row] -sticky ew -padx 5
  grid .$mainframe.translation_xsbar -row [incr row] -sticky ew -padx 5 -pady {0 5}
 
  grid columnconfigure .$mainframe 0 -weight 1
  grid rowconfigure .$mainframe 0 -weight 1
 
  # the bottom button     
  set ButtonText [::FR_general::ButtonsWithSameWidth [list [msgcat::mc "Okay"] [msgcat::mc "Cancel"]]]
 
  button .$bottomframe.okay -text [lindex $ButtonText 0] -state normal -width [lindex $ButtonText 2] -command [list ::tk_msg::EditEntrySubOkay]
  button .$bottomframe.cancel -text [lindex $ButtonText 1] -width [lindex $ButtonText 2] -state normal -command [list ::tk_msg::EditEntrySubCancel]
               
  pack .$bottomframe.okay -side left -padx {5 0} -pady 5 -expand yes -fill x
  pack .$bottomframe.cancel -side left -padx 5 -pady 5 -expand yes -fill x
  
  bind .$VAR(EditEntryWindow) <KeyPress-Escape> [list .$bottomframe.cancel invoke]
  bind .$VAR(EditEntryWindow) <KeyPress-Return> [list .$bottomframe.okay invoke]


  .$mainframe.orginal insert end $Message
 
 
  if {$Translation eq ""} \
  {
    .$mainframe.translation insert end $Message
  } else \
  {
    .$mainframe.translation insert end $Translation
  }
 
  focus .$mainframe.translation
  .$mainframe.translation selection range 0 end

        
  ::FR_general::CenterWindow .$VAR(EditEntryWindow) $VAR(Parent)
  
  wm deiconify .$VAR(EditEntryWindow)
 
  wm protocol .$VAR(EditEntryWindow) WM_DELETE_WINDOW [list .$bottomframe.cancel invoke]
  
  vwait ::tk_msg::VAR(EditEntryStop)
  return $VAR(EditEntryReturnValue)
}


#---the bottom cancel button
proc ::tk_msg::EditEntrySubCancel {} \
{
  variable VAR
 
  focus $VAR(Parent)
  
  destroy .$VAR(EditEntryWindow)
  
  set VAR(EditEntryStop) 1
}


#---the bottom ok button
proc ::tk_msg::EditEntrySubOkay {} \
{
  variable VAR
 
  set VAR(EditEntryReturnValue) [.$VAR(TranslationEntry) get]

  # we close the dialog
  ::tk_msg::EditEntrySubCancel
}
